# we use the upstream version from http_parser.h as the SONAME
%global somajor 2
%global sominor 0

%global git_date 20121128
%global git_commit_hash cd01361
%global github_seq 7

%define libname %mklibname http_parser %{somajor}
%define devname http-parser-devel

%define strictlibname %mklibname http_parser_strict %{somajor}

Name:           http-parser
Version:        %{somajor}.%{sominor}
Release:        0.%{git_date}git%{git_commit_hash}.1
Summary:        HTTP request/response parser for C

Group:          System/Libraries
License:        MIT
URL:            http://github.com/joyent/http-parser
# download from https://github.com/joyent/http-parser/tarball/%%{version}
Source0:        joyent-http-parser-v%{version}-%{github_seq}-g%{git_commit_hash}.tar.gz

# Build shared library with SONAME using gyp and remove -O flags so optflags take over
# TODO: do this nicely upstream
Patch1:		http-parser-gyp-sharedlib.patch

BuildRequires:	gyp

%description
This is a parser for HTTP messages written in C. It parses both requests and
responses. The parser is designed to be used in performance HTTP applications.
It does not make any syscalls nor allocations, it does not buffer data, it can
be interrupted at anytime. Depending on your architecture, it only requires
about 40 bytes of data per message stream (in a web server that is per
connection).


%package -n %{devname}
Group:          Development/Other
Summary:        Development headers and libraries for http-parser
Requires:       %{libname} = %{EVRD}
Requires:       %{strictlibname} = %{EVRD}

%description -n %{devname}
Development headers and libraries for http-parser.

%package -n %{libname}
Summary:    %{summary}
Group:      System/Libraries

%description -n %{libname}
This is a parser for HTTP messages written in C. It parses both requests and
responses. The parser is designed to be used in performance HTTP applications.
It does not make any syscalls nor allocations, it does not buffer data, it can
be interrupted at anytime. Depending on your architecture, it only requires
about 40 bytes of data per message stream (in a web server that is per
connection).

%package -n %{strictlibname}
Summary:    %{summary}
Group:      System/Libraries

%description -n %{strictlibname}
Http-parser strict library.

%prep
%setup -q -n joyent-http-parser-%{git_commit_hash}
%patch1


%build
# TODO: fix -fPIC upstream
export CFLAGS='%{optflags} -fPIC'
gyp -f make --depth=`pwd` http_parser.gyp
%make BUILDTYPE=Release 


%install
install -d %{buildroot}%{_includedir}
install -d %{buildroot}%{_libdir}

install -pm644 http_parser.h %{buildroot}%{_includedir}

#install regular variant
install out/Release/lib.target/libhttp_parser.so.%{somajor} %{buildroot}%{_libdir}/libhttp_parser.so.%{somajor}.%{sominor}
ln -sf libhttp_parser.so.%{somajor}.%{sominor} %{buildroot}%{_libdir}/libhttp_parser.so.%{somajor}
ln -sf libhttp_parser.so.%{somajor}.%{sominor} %{buildroot}%{_libdir}/libhttp_parser.so

#install strict variant
install out/Release/lib.target/libhttp_parser_strict.so.%{somajor} %{buildroot}%{_libdir}/libhttp_parser_strict.so.%{somajor}.%{sominor}
ln -sf libhttp_parser_strict.so.%{somajor}.%{sominor} %{buildroot}%{_libdir}/libhttp_parser_strict.so.%{somajor}
ln -sf libhttp_parser_strict.so.%{somajor}.%{sominor} %{buildroot}%{_libdir}/libhttp_parser_strict.so


%check
export LD_LIBRARY_PATH='./out/Release/lib.target' 
./out/Release/test-nonstrict
./out/Release/test-strict


%files
%doc AUTHORS CONTRIBUTIONS LICENSE-MIT README.md

%files -n %{devname}
%{_includedir}/*
%{_libdir}/libhttp_parser.so
%{_libdir}/libhttp_parser_strict.so

%files -n %{libname}
%{_libdir}/libhttp_parser.so.*

%files -n %{strictlibname}
%{_libdir}/libhttp_parser_strict.so.*

%changelog

* Wed Apr 30 2014 Denis Silakov <denis.silakov@rosalab.ru> 2.0-0.20121128gitcd01361.1
- (5210bf4) Imported from SRPM


